# -*- coding: utf-8 -*-

'''
Copyright (C) 2014                                                     

This program is free software: you can redistribute it and/or modify   
it under the terms of the GNU General Public License as published by   
the Free Software Foundation, either version 3 of the License, or      
(at your option) any later version.                                    

This program is distributed in the hope that it will be useful,        
but WITHOUT ANY WARRANTY; without even the implied warranty of         
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          
GNU General Public License for more details.                           

You should have received a copy of the GNU General Public License      
along with this program. If not, see <http://www.gnu.org/licenses/>  
'''                                                                            

import urllib,urllib2,re,os,requests,json,base64
import xbmcplugin,xbmcgui,xbmcaddon

addon = xbmcaddon.Addon(id='plugin.video.itv.sctv')
profile = addon.getAddonInfo('profile')
home = addon.getAddonInfo('path')
dataPatch = xbmc.translatePath(os.path.join(home, 'resources'))
logos = xbmc.translatePath(os.path.join(dataPatch, 'logos\\'))
fanart = xbmc.translatePath(os.path.join(home, 'fanart.jpg'))
icon = xbmc.translatePath(os.path.join(home, 'icon.png'))
sys.path.append(os.path.join(home,'resources','lib'));from BeautifulSoup import BeautifulSoup;import urlfetch;import hashlib

def d ( k , e ) :
    data = [ ]
    e = base64.urlsafe_b64decode ( e )
    for i in range ( len ( e ) ) :
        ch1 = k [ i % len ( k ) ]
        ch2 = chr ( ( 256 + ord ( e [ i ] ) - ord ( ch1 ) ) % 256 )
        data.append ( ch2 )
    return "".join ( data )

source          = d('stv','2-jq466louzY4Nek3Ojs4-Dr5qLk2OilxsjIuLXDot3q6bTp1ujsoeju5w==')
device_model    = d('stv','y93X4uHfnsbb1-HfnsLl59mhpg==')
fake_device_id  = d('stv','q6arp6eq')
manufacturer_id = d('stv','pay4qLq8ubW3o6eutrenqKS6rLq3tq23pKa7paq5pKw=')
tok             = 'VjNqT05kcTVUMDVrUnpWVU1YQnJVbXBXVUZaclNsTlZSbEYzVUZFOVBRPT0='

query_string = {'tok' : tok,'cli' : '1','lang': 'vi'}

headers = {'Content-Type' : 'application/x-www-form-urlencoded; charset = UTF-8', 'Accept-Encoding' : 'gzip'}

def alert(message,title="[COLOR red]Thông báo![/COLOR]"):
    xbmcgui.Dialog().ok(title,"",message)
	
def notification(message, timeout=1000):
    xbmc.executebuiltin((u'XBMC.Notification("%s", "%s", %s, %s)' % ('SCTV', message, timeout, icon)).encode("utf-8"))

def main() :
    if len(addon.getSetting('usernamesctv')) < 1:
			d = xbmcgui.Dialog().yesno('Thông báo!', '', 'Bạn chưa đăng nhập tài khoản SCTV. Vui lòng đăng nhập để xem được nội dung này', '', 'Thoát', 'OK. Đăng nhập ngay')
			if d:
			    addon.openSettings()
			    mainx()
			else:
			    sys.exit()
    else:
        mainx()	
	
def mainx():
    phone = addon.getSetting('usernamesctv')
    passw = addon.getSetting('passwordsctv')
    hash_object = hashlib.md5(passw)
    passw = hash_object.hexdigest()
    valid_device_id, valid_user_id  = login(phone, passw)
    if valid_user_id:
        content = makeRequest(source)
        match = re.compile("'label': '(.+?)', 'path': '(.+?)', 'thumbnail': '(.+?)'").findall(content)
        for title, href, thumb in match:
            addDir( title, href.split('=')[-1], 100, thumb, isFolder=False)
        xbmc.executebuiltin('Container.SetViewMode(500)')
    else:
        d = xbmcgui.Dialog().yesno('Thông báo!', '', 'Tên đăng nhập hoặc mật khẩu chưa đúng. Hãy nhập lại.', '', 'Thoát', 'OK. Nhập ngay')
        if d :
            addon.openSettings()
            main()
        else :
            sys.exit()

def login(mobile, passw):
	login_uri = 'https://aaa-stage.sctv.vn/apiott/member_login'
	payloads = {
		'device_model'    : device_model,
		'password'        : passw,
		'device_id'       : fake_device_id,
		'manufacturer_id' : manufacturer_id,
		'type_id'         : '2',
		'mobile'          : mobile,
		'member_id'       : '0'
	}
	js = requests.post(login_uri,params=query_string,data=payloads,headers=headers).json()

	if js['result'] == '1':
		return js['data'][0]['DEVICE_ID'].encode('utf8'), js['data'][0]['MEMBER_ID'].encode('utf8')
	else:
		return None, None			
			
def play(url,phone="",passw=""):
	if phone == "": phone = addon.getSetting('usernamesctv')
	if passw == "":
		passw = addon.getSetting('passwordsctv')
		hash_object = hashlib.md5(passw)
		passw = hash_object.hexdigest()
	valid_device_id, valid_user_id  = login(phone, passw)
	GetChannelPlayURL(url,valid_user_id,valid_device_id)		

def GetChannelPlayURL(url, valid_user_id, valid_device_id):
	channel_id = url
	media_Url = None
	if valid_user_id:
		channel_play    = 'https://api-stage.sctv.vn/apiott/channel_play'
		payloads = {
			'image_type'     : 'app_192_276',
			'product_id'     : '3',
			'channel_id'     : channel_id,
			'cate_id'        : '-1',
			'device_id'      : valid_device_id,
			'manufacturer_id': manufacturer_id,
			'member_id'      : valid_user_id
		}
		res = requests.post(channel_play,params=query_string,data=payloads,headers=headers)
		try :
			media_Url = res.json()['data'][0]['RESULT_URL']
		except:
			pass
	if channel_id in ["2","106"]:
		res = requests.get(media_Url).text

		res = re.compile("chunklist_.+?m3u8").findall(res)[-2]

		media_Url = "/".join(media_Url.split("/")[:-1] + [res])
	item = xbmcgui.ListItem(path=media_Url)
	xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
	return media_Url

def addDir(name,url,mode,iconimage,isFolder=False):
    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)
    ok=True
    liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    liz.setInfo( type="Video", infoLabels={ "Title": name } )
    if not isFolder:
        liz.setProperty('IsPlayable', 'true')
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=isFolder)
    return ok

def makeRequest(url, headers=None):
    if headers is None:
        headers = {'User-agent' : 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36',
                 'Referer' : 'http://www.google.com'}
    try:
        req = urllib2.Request(url,headers=headers)
        f = urllib2.urlopen(req)
        body=f.read()
        return body
    except:
        pass
	
def get_params():
    param=[]
    paramstring=sys.argv[2]
    if len(paramstring)>=2:
        params=sys.argv[2]
        cleanedparams=params.replace('?','')
        if (params[len(params)-1]=='/'):
            params=params[0:len(params)-2]
        pairsofparams=cleanedparams.split('&')
        param={}
        for i in range(len(pairsofparams)):
            splitparams={}
            splitparams=pairsofparams[i].split('=')
            if (len(splitparams))==2:
                param[splitparams[0]]=splitparams[1]
    return param

params=get_params()
url=None
name=None
mode=None
iconimage=None

try:url=urllib.unquote_plus(params["url"])
except:pass
try:name=urllib.unquote_plus(params["name"])
except:pass
try:mode=int(params["mode"])
except:pass
try:iconimage=urllib.unquote_plus(params["iconimage"])
except:pass

if mode==None or url==None or len(url)<1:main()

elif mode==100:
    dialogWait = xbmcgui.DialogProgress()
    dialogWait.create('*ITV*SCTV', 'Đang tải. Vui lòng chờ trong giây lát...')
    play(url,phone="",passw="")
    dialogWait.close()
    del dialogWait
  
xbmcplugin.endOfDirectory(int(sys.argv[1]))